using System;

namespace CustomBandObjectLib
{
	/// <summary>
	/// Summary description for FavoritesHandler.
	/// </summary>
	public class FavoritesHandler
	{
		private object[] aFavorites;
		private RegistryHandler Reg;

		public FavoritesHandler(RegistryHandler Reg)
		{
			this.Reg = Reg;
			LoadFavorites();
		}

		public void LoadFavorites()
		{
			char[] sep = new char[1];
			sep[0] = ',';
			string favs = Reg.GetFavorites();
			string[] aFavs = favs.Split(sep);

			aFavorites = new object[aFavs.Length / 4];
			for (int i = 0;i < aFavs.Length / 4; i++)
			{
				aFavorites[i] = new Favorite((string)aFavs[(i*4)],(string)aFavs[(i*4)+1],(string)aFavs[(i*4)+2],(string)aFavs[(i*4)+3]);
			}
		}

		
		public bool GetFavoriteCookie(string url)
		{
			foreach (Favorite f in aFavorites)
			{
				if (f.Url == url)
				{
					return f.Cookie;
				}
			}
			return false;
		}

		public bool GetFavoriteDownLoad(string url)
		{
			foreach (Favorite f in aFavorites)
			{
				if (f.Url == url)
				{
					return f.DownLoad;
				}
			}
			return false;
		}

		public string GetFavoriteUrl(string url)
		{
			foreach (Favorite f in aFavorites)
			{
				if (f.Url == url)
				{
					return f.Url;
				}
			}
			return null;
		}

		
		public string GetFavoriteTrigger(string url)
		{
			foreach (Favorite f in aFavorites)
			{
				if (f.Url == url)
				{
					return f.Trigger;
				}
			}
			return null;
		}
	}
}
