using System;

namespace CustomBandObjectLib
{
	/// <summary>
	/// Summary description for Log.
	/// </summary>
	public class Log
	{
		public event LogEventHandler EntryWrittenEvent;

		public enum LogType
		{
			Information = 1,
			Error = 2
		}

		public Log(){
		}

		public virtual void WriteLog(string Message, LogType Type)
		{
			if (EntryWrittenEvent != null)
			{
				EntryWrittenEvent(this, new LogEventArgs(Message,Type));
			}
		}
	}

	public delegate void LogEventHandler(object sender, LogEventArgs e);
	public class LogEventArgs:EventArgs
	{
		private string _message;
		private Log.LogType _type;

		public LogEventArgs(string Message, Log.LogType Type)
		{
			this.Message = Message;
			this.Type = Type;
		}

		public string Message
		{
			get
			{ 
				return this._message;
			}
			set
			{ 
				this._message = value;
			}
		}

		public Log.LogType Type
		{
			get
			{ 
				return this._type;
			}
			set
			{ 
				this._type = value;
			}
		}
	}
}
