using System;
using Microsoft.Win32;

namespace CustomBandObjectLib
{
	/// <summary>
	/// Summary description for RegistryHandler.
	/// </summary>
	public class RegistryHandler
	{
		public RegistryHandler()
		{
			CheckReg();
		}

		private void CheckReg()
		{
			RegistryKey key = Registry.LocalMachine.OpenSubKey( "Software\\TorrentBar",true );

			if ( key == null ) 
			{
				key = Registry.LocalMachine.CreateSubKey( "Software\\TorrentBar" );
				key.SetValue("Server","");
				key.SetValue("Port","");
				key.SetValue("Login","");
				key.SetValue("Password","");
				key.SetValue("Refresh","");
				key.SetValue("Favorites","");
			}
		}

		public string GetServer()
		{
			RegistryKey key = Registry.LocalMachine.OpenSubKey( "Software\\TorrentBar" );
			return key.GetValue("Server").ToString();
		}

		public string GetPort()
		{
			RegistryKey key = Registry.LocalMachine.OpenSubKey( "Software\\TorrentBar" );
			return key.GetValue("Port").ToString();
		}

		public string GetLogin()
		{
			RegistryKey key = Registry.LocalMachine.OpenSubKey( "Software\\TorrentBar" );
			return key.GetValue("Login").ToString();
		}

		public string GetPassword()
		{
			RegistryKey key = Registry.LocalMachine.OpenSubKey( "Software\\TorrentBar" );
			return key.GetValue("Password").ToString();
		}

		public string GetRefresh()
		{
			RegistryKey key = Registry.LocalMachine.OpenSubKey( "Software\\TorrentBar" );
			return key.GetValue("Refresh").ToString();
		}

		public string GetFavorites()
		{
			RegistryKey key = Registry.LocalMachine.OpenSubKey( "Software\\TorrentBar" );
			return key.GetValue("Favorites").ToString();
		}

		public void SetFavorites(string favs)
		{
			RegistryKey key = Registry.LocalMachine.OpenSubKey( "Software\\TorrentBar",true);
			key.SetValue("Favorites",favs);
		}
	}
}
