using System;
using System.Runtime.InteropServices;

namespace CustomBandObjectLib
{
	/// <summary>
	/// Summary description for ConnectionPointHelper.
	/// </summary>
	public class ConnectionPointHelperClass
	{
		private UCOMIConnectionPoint m_ConnectionPoint = null;
		private int m_Cookie = 0;
		private int m_Count = 0;
		private Guid m_IID = Guid.Empty;

		public ConnectionPointHelperClass(ref Guid i_IID)
		{
			m_IID = i_IID;
		}

		public void Advise (ref object i_Source, ref object i_Sink)
		{
			if (++m_Count == 1)
			{
				UCOMIConnectionPointContainer ConnectionPointContainer = (UCOMIConnectionPointContainer)i_Source;
				ConnectionPointContainer.FindConnectionPoint(ref m_IID, out m_ConnectionPoint);
				m_ConnectionPoint.Advise(i_Sink, out m_Cookie);
			}
		}

		public void Unadvise ()
		{
			if (--m_Count == 0)
			{
				m_ConnectionPoint.Unadvise(m_Cookie);
				m_Cookie = 0;
				Marshal.ReleaseComObject(m_ConnectionPoint);
				m_ConnectionPoint = null;
			}
		}
	}
}
