using System;
using System.Runtime.InteropServices;
using System.Net;
using System.Text.RegularExpressions;
using Amib.Threading;


namespace CustomBandObjectLib
{
	/// <summary>
	/// Summary description for IEEvents.
	/// </summary>
	/// 
	[Guid("47557A79-00EB-45af-98B3-7F2FAB317BCA")]
	public class IEEvents: Common, IMyWebBrowserEvents
	{

		public delegate void SpecialFileDownloadDelegate(SpecialFileDownloadEventArgs e); 
		public event SpecialFileDownloadDelegate SpecialFileDownLoadEvent;
		bool globalFlag = true;
		object pDisp;
		object URL;
		object Flags;
		object TargetFrameName;
		object PostData;
		object Headers;
		bool Cancel;

		public void FileDownload(ref bool Cancel,ref bool Load)
		{

			if (globalFlag) 
			{
				string str = base.BuildRegExString(new Uri((string)URL)); 
				string regexIdentifiers = "(?:" + str + ")(?:\\?[^.]*|\\z)";
				string regexTorrent = "(?:\\.torrent)(?:\\?[^.]*|\\z)";

				if ((new Regex(regexIdentifiers).IsMatch((string)URL)) && str != "")
				{
					Load = true;
					System.Threading.ThreadPool.QueueUserWorkItem(new System.Threading.WaitCallback(FollowURL),(string)URL);
				}
				else if  (new Regex(regexTorrent).IsMatch((string)URL)) 
				{
					Load = true;
					SpecialFileDownLoadEvent(new SpecialFileDownloadEventArgs((string)URL));
				}
			}
			else
			{
				globalFlag = true;
			}
		}
		
		public void DocumentComplete(object pDisp, ref object URL){}

		public void NewWindow3(ref object a, ref bool b, uint c, string d, string e) {}

		public void NewWindow2(ref object ppDisp, ref bool Cancel) { }

		public void OnQuit() {}

		public void BeforeNavigate2(object pDisp, ref object URL,
			ref object Flags, ref object TargetFrameName, ref object 
			PostData,
			ref object Headers, ref bool Cancel) 
		{
			this.pDisp = pDisp;
			this.URL = URL;
			this.Flags = Flags;
			this.TargetFrameName = TargetFrameName;
			this.PostData = PostData;
			this.Headers = Headers;
			this.Cancel = Cancel;
			//base.LocationURL = base.Explorer.LocationURL;
		}

		private void FollowURL(object sURL)
		{
			bool isTorrent = false;
			IWorkItemResult result = Pool.QueueWorkItem(new WorkItemCallback(CheckLink),sURL);
			if (!result.IsCompleted)
			{
				 isTorrent = (bool)result.GetResult();
			}

			if (isTorrent)
			{
				SpecialFileDownLoadEvent(new SpecialFileDownloadEventArgs((string)sURL));
			}
			else
			{
				globalFlag = false;
				this.BeforeNavigate2(pDisp,ref URL,ref Flags,ref TargetFrameName,ref PostData, ref Headers,ref Cancel);
			}
		}

		public void NavigateComplete2(object pDisp, ref object URL) {}
		    
		public void NavigateError(object pDisp, ref object URL,
		ref object TargetFrameName, ref object StatusCode, ref bool 
		Cancel) {}

		public void OnVisible(bool Visible) {}

		public void OnToolBar(bool ToolBar){}

		public void OnMenuBar(bool MenuBar){}

		public void OnStatusBar(bool StatusBar){}

		public void OnFullScreen(bool FullScreen){}

		public void OnTheaterMode(bool TheaterMode){}

		public void ClientToHostWindow(ref int x, ref int y){}

		public void FileDownload(ref bool Cancel){}

		public void PrintTemplateInstantiation(object pDisp) {}

		public void PrintTemplateTeardown(object pDisp) {}

		public void PrivacyImpactedStateChange(bool bImpacted){}

		public void SetSecureLockIcon(int SecureLockIcon){}

		public void UpdatePageStatus(object pDisp, ref object nPage, ref 
		object fDone){}

		public void WindowClosing(bool bIsChildWindow, ref bool bCancel){}

		public void WindowSetHeight(int Height){}

		public void WindowSetWidth(int Width){}

		public void WindowSetTop(int Top){}

		public void WindowSetLeft(int Left){}

		public void WindowSetResizable(bool bResizable){}

		public void StatusTextChange(string Text) {}

		public void ProgressChange(int Progress, int ProgressMax) {}

		public void CommandStateChange(int Command, bool Enable) {}

		public void DownloadBegin() { }

		public void DownloadComplete() {}

		public void TitleChange(string Text) {}

		public void PropertyChange(string szProperty) {}
	}
}
